# mypy-boto3-autoscaling

[![PyPI - mypy-boto3-autoscaling](https://img.shields.io/pypi/v/mypy-boto3-autoscaling.svg?color=blue)](https://pypi.org/project/mypy-boto3-autoscaling)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-autoscaling.svg?color=blue)](https://pypi.org/project/mypy-boto3-autoscaling)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-autoscaling](#mypy-boto3-autoscaling)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)


Type annotations for
[boto3.AutoScaling 1.13.26](https://boto3.amazonaws.com/v1/documentation/api/1.13.26/reference/services/autoscaling.html#AutoScaling) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.3](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-autoscaling](#mypy-boto3-autoscaling)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `AutoScaling` service.

```bash
python -m pip install boto3-stubs[autoscaling]

# update installed packages index for automated type discovery
python -m mypy_boto3
```

Use `boto3` with `mypy_boto3_autoscaling` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_autoscaling import AutoScalingClient

# Now mypy can check if your code is valid.
client: AutoScalingClient = boto3.client("autoscaling")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: AutoScalingClient = session.client("autoscaling")



# Annotated paginators are included as well

import mypy_boto3_autoscaling.paginator as autoscaling_paginators

describe_auto_scaling_groups_paginator: autoscaling_paginators.DescribeAutoScalingGroupsPaginator = client.get_paginator("describe_auto_scaling_groups")
describe_auto_scaling_instances_paginator: autoscaling_paginators.DescribeAutoScalingInstancesPaginator = client.get_paginator("describe_auto_scaling_instances")
describe_launch_configurations_paginator: autoscaling_paginators.DescribeLaunchConfigurationsPaginator = client.get_paginator("describe_launch_configurations")
describe_load_balancer_target_groups_paginator: autoscaling_paginators.DescribeLoadBalancerTargetGroupsPaginator = client.get_paginator("describe_load_balancer_target_groups")
describe_load_balancers_paginator: autoscaling_paginators.DescribeLoadBalancersPaginator = client.get_paginator("describe_load_balancers")
describe_notification_configurations_paginator: autoscaling_paginators.DescribeNotificationConfigurationsPaginator = client.get_paginator("describe_notification_configurations")
describe_policies_paginator: autoscaling_paginators.DescribePoliciesPaginator = client.get_paginator("describe_policies")
describe_scaling_activities_paginator: autoscaling_paginators.DescribeScalingActivitiesPaginator = client.get_paginator("describe_scaling_activities")
describe_scheduled_actions_paginator: autoscaling_paginators.DescribeScheduledActionsPaginator = client.get_paginator("describe_scheduled_actions")
describe_tags_paginator: autoscaling_paginators.DescribeTagsPaginator = client.get_paginator("describe_tags")
```

## Automated type discovery

`mypy_boto3` package can generate index for `mypy_boto3_autoscaling` and other installed services.

```bash
# Run this command when you add or remove service packages
python -m mypy_boto3
```

Generated index provides overloads for `boto3.client` and `boto3.service`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully
- `VSCode` does not currently support function overloads

Also, generated index allows you to import types from `mypy_boto3`:

```python
# you can replace imports
import mypy_boto3_autoscaling as autoscaling
from mypy_boto3_autoscaling import AutoScalingClient

# with these
from mypy_boto3 import autoscaling
from mypy_boto3.autoscaling import AutoScalingClient
```